; *** Initialize SNES to default startup values
; Last revision: 10.24.1996
; Call:
;       Native mode
init_snes:
                pha                             ; Save registers used.
                php                             ; Save processor status.

                rep     #$30                    ; Set AXY to 16-bit
                sep     #$20                    ; Set A to 8-bit
                lda     #$8f                    ; Screen off, full brightness.
                sta     $2100                   ; Store to screen register.
                stz     $2101                   ; sprite register (size + address in VRAM)
                stz     $2102                   ; sprite registers (address of sprite memory [OAM])
                stz     $2103                   ; "
                stz     $2105                   ; set graphics Mode 0
                stz     $2106                   ; no planes, no mosiac
                stz     $2107                   ; plane 0 map VRAM location ($0000 vram)
                stz     $2108                   ; plane 1 map VRAM location
                stz     $2109                   ; plane 2 "
                stz     $210a                   ; plane 3 "
                stz     $210b                   ; plane 0+1 tile data location
                stz     $210c                   ; plane 0+2 "
                stz     $210d                   ; plane 0 scroll x (first 8 bits)
                stz     $210d                   ; plane 0 scroll x (last 3 bits) write to reg twice
                stz     $210e                   ; plane 0 scroll y "
                stz     $210e                   ; plane 0 scroll y "
                stz     $210f                   ; plane 1 scroll x (first 8 bits)
                stz     $210f                   ; plane 1 scroll x (last 3 bits) write to reg twice
                stz     $2110                   ; plane 1 scroll y "
                stz     $2110                   ; plane 1 scroll y "
                stz     $2111                   ; plane 2 scroll x (first 8 bits)
                stz     $2111                   ; plane 2 scroll x (last 3 bits) write to reg twice
                stz     $2112                   ; plane 2 scroll y "
                stz     $2112                   ; plane 2 scroll y "
                stz     $2113                   ; plane 3 scroll x (first 8 bits)
                stz     $2113                   ; plane 3 scroll x (last 3 bits) write to reg twice
                stz     $2114                   ; plane 3 scroll y "
                stz     $2114                   ; plane 3 scroll y "
                lda     #$80                    ; increase VRAM after writes to $2118.19
                sta     $2115                   ; store to VRAM increment register
                stz     $2116                   ; VRAM address low
                stz     $2117                   ; VRAM address hi
                stz     $211a                   ; init mode 7 setting reg
                stz     $211b                   ; mode 7 matrix parameter A register (low)
                stz     $211b                   ; Mode 7 matrix parameter A register (low)
                lda     #$01
                sta     $211b                   ; Mode 7 matrix parameter A register (high)
                stz     $211c                   ; Mode 7 matrix parameter B register (low)
                stz     $211c                   ; Mode 7 matrix parameter B register (high)
                stz     $211d                   ; Mode 7 matrix parameter C register (low)
                stz     $211d                   ; Mode 7 matrix parameter C register (high)
                stz     $211e                   ; Mode 7 matrix parameter D register (low)
                lda     #$01
                sta     $211e                   ; Mode 7 matrix parameter D register (high)
                stz     $211f                   ; Mode 7 center position X register (low)
                stz     $211f                   ; Mode 7 center position X register (high)
                stz     $2120                   ; Mode 7 center position Y register (low)
                stz     $2120                   ; Mode 7 center position Y register (high)
                stz     $2121                   ; Color number register ($0-ff)
                stz     $2123                   ; BG1 & BG2 Window mask setting register
                stz     $2124                   ; BG3 & BG4 Window mask setting register
                stz     $2125                   ; OBJ & Color Window mask setting register
                stz     $2126                   ; Window 1 left position register
                stz     $2127                   ; Window 2 left position register
                stz     $2128                   ; Window 3 left position register
                stz     $2129                   ; Window 4 left position register
                stz     $212a                   ; BG1, BG2, BG3, BG4 Window Logic register
                stz     $212b                   ; OBJ, Color Window Logic Register (or,and,xor,xnor)
                stz     $212c                   ; Main Screen designation (planes, sprites enable)
                stz     $212d                   ; Sub Screen designation
                stz     $212e                   ; Window mask for Main Screen
                stz     $212f                   ; Window mask for Sub Screen
                lda     #$30
                sta     $2130                   ; Color addition & screen addition init setting
                stz     $2131                   ; Add/Sub sub designation for screen, sprite, color
                lda     #$e0
                sta     $2132                   ; color data for addition/subtraction
                stz     $2133                   ; Screen setting (interlace x,y/enable SFXdata)
                stz     $4200                   ; Enable V-blank, interrupt, Joypad register
                lda     #$ff
                stz     $4201                   ; Programmable I/O port
                stz     $4202                   ; Multiplicand A
                stz     $4203                   ; Multiplier B
                stz     $4204                   ; Multiplier C
                stz     $4205                   ; Multiplicand C
                stz     $4206                   ; Divisor B
                stz     $4207                   ; Horizontal Count Timer
                stz     $4208                   ; Horizontal Count Timer MSB (most significant bit)
                stz     $4209                   ; Vertical Count Timer
                stz     $420a                   ; Vertical Count Timer MSB
                stz     $420b                   ; General DMA enable (bits 0-7)
                stz     $420c                   ; Horizontal DMA (HDMA) enable (bits 0-7)
                stz     $420d                   ; Access cycle designation (slow/fast rom)

                plp                             ; Restore processor status.
                pla                             ; Restore all registers.
                rts

